#ifndef _DYNAMIXEL_H
#define _DYNAMIXEL_H

#include "dyn_common.h"

#define     DYN_HEADER_OFF      0
#define     DYN_ID_OFF          2
#define     DYN_LENGTH_OFF      3
#define     DYN_INST_OFF        4
#define     DYN_ERROR_OFF       4
#define     DYN_DATA_OFF        5

void dyn_copy_packet(unsigned char *source, unsigned char *destination);
unsigned char dyn_get_id(unsigned char *packet);
unsigned char dyn_get_length(unsigned char *packet);
TDynInstruction dyn_get_instruction(unsigned char *packet);
unsigned char dyn_check_checksum(unsigned char *packet);

// instruction packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char instruction;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynInst;
*/
unsigned char dyn_convert_v2_inst_packet(unsigned char *source, unsigned char *destination);
/* ping instruction */
void dyn_init_ping_packet(unsigned char *packet,unsigned char id);
/* read instruction */
void dyn_init_read_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length);
unsigned char dyn_get_read_length(unsigned char *packet);
unsigned char dyn_get_read_address(unsigned char *packet);
/* write instruction */
void dyn_init_write_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length,unsigned char *data);
unsigned char dyn_get_write_address(unsigned char *packet);
unsigned char dyn_get_write_length(unsigned char *packet);
unsigned char dyn_get_write_data(unsigned char *packet,unsigned char *data);
/* registered write instruction */
void dyn_init_reg_write_packet(unsigned char *packet,unsigned char id,unsigned char address,unsigned char length,unsigned char *data);
unsigned char dyn_get_reg_write_address(unsigned char *packet);
unsigned char dyn_get_reg_write_length(unsigned char *packet);
unsigned char dyn_get_reg_write_data(unsigned char *packet,unsigned char *data);
/* action instruction */
void dyn_init_action_packet(unsigned char *packet);
/* reset instruction */
void dyn_init_reset_packet(unsigned char *packet,unsigned char id);
/* sync write instruction */
void dyn_init_sync_write_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned char address,unsigned char length,TWriteData *data);
unsigned char dyn_sync_write_id_present(unsigned char *packet,unsigned char id,unsigned char *address,unsigned char *length,unsigned char *data);
/* bulk read instruction */
void dyn_init_bulk_read_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned char *address,unsigned char *length);
unsigned char dyn_bulk_read_id_present(unsigned char *packet,unsigned char id,unsigned char *address,unsigned char *length);

// status packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char error;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynStatus;
*/

unsigned char dyn_convert_v2_status_packet(unsigned char *source, unsigned char *destination);
void dyn_init_status_packet(unsigned char *packet,unsigned char id,TDynError error,unsigned char length,unsigned char *data);
TDynError dyn_get_status_error(unsigned char *packet);
/* read instruction status packet */
unsigned char dyn_get_read_status_data(unsigned char *packet,unsigned char *data);
unsigned char dyn_get_read_status_id(unsigned char *packet);

#endif
