#ifndef _DYNAMIXEL2_H
#define _DYNAMIXEL2_H

#include "dyn_common.h"

#define     DYN2_HEADER_OFF      0
#define     DYN2_RESERVED        3
#define     DYN2_ID_OFF          4
#define     DYN2_LENGTH_OFF      5
#define     DYN2_INST_OFF        7
#define     DYN2_ERROR_OFF       8
#define     DYN2_DATA_OFF        8


void dyn2_copy_packet(unsigned char *source, unsigned char *destination);
unsigned char dyn2_get_id(unsigned char *packet);
unsigned short int dyn2_get_length(unsigned char *packet);
TDynInstruction dyn2_get_instruction(unsigned char *packet);
unsigned char dyn2_check_checksum(unsigned char *packet);

// instruction packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char instruction;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynInst;
*/
unsigned char dyn2_convert_v1_inst_packet(unsigned char *source, unsigned char *destination);
/* ping instruction */
void dyn2_init_ping_packet(unsigned char *packet,unsigned char id);
/* read instruction */
void dyn2_init_read_packet(unsigned char *packet,unsigned char id,unsigned short int address,unsigned short int length);
unsigned short int dyn2_get_read_length(unsigned char *packet);
unsigned short int dyn2_get_read_address(unsigned char *packet);
/* write instruction */
void dyn2_init_write_packet(unsigned char *packet,unsigned char id,unsigned short int address,unsigned short int length,unsigned char *data);
unsigned short int dyn2_get_write_address(unsigned char *packet);
unsigned short int dyn2_get_write_length(unsigned char *packet);
unsigned short int dyn2_get_write_data(unsigned char *packet,unsigned char *data);
/* registered write instruction */
void dyn2_init_reg_write_packet(unsigned char *packet,unsigned char id,unsigned short int address,unsigned short int length,unsigned char *data);
unsigned short int dyn2_get_reg_write_address(unsigned char *packet);
unsigned short int dyn2_get_reg_write_length(unsigned char *packet);
unsigned short int dyn2_get_reg_write_data(unsigned char *packet,unsigned char *data);
/* action instruction */
void dyn2_init_action_packet(unsigned char *packet);
/* reset instruction */
void dyn2_init_reset_packet(unsigned char *packet,unsigned char id,unsigned char mode);
/* sync write instruction */
void dyn2_init_sync_write_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned short int address,unsigned short int length,TWriteData *data);
unsigned char dyn2_sync_write_id_present(unsigned char *packet,unsigned char id,unsigned short int *address,unsigned short int *length,unsigned char *data);
/* sync read instruction */
void dyn2_init_sync_read_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned short int address,unsigned short int length);
unsigned char dyn2_sync_read_id_present(unsigned char *packet,unsigned char id,unsigned short int *address,unsigned short int *length);
/* bulk read instruction */
void dyn2_init_bulk_read_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned short int *address,unsigned short int *length);
unsigned char dyn2_bulk_read_id_present(unsigned char *packet,unsigned char id,unsigned short int *address,unsigned short int *length);
/* bulk write instruction */
void dyn2_init_bulk_write_packet(unsigned char *packet,unsigned char num_servos,unsigned char *servo_ids,unsigned short int *address,unsigned short int *length,TWriteData *data);
unsigned char dyn2_bulk_write_id_present(unsigned char *packet,unsigned char id,unsigned short int *address,unsigned short int *length,unsigned char *data);

// status packet
/*
typedef struct{
  unsigned char header[2];
  unsigned char id;
  unsigned char length;
  unsigned char error;
  unsigned char data[MAX_DATA_LENGTH];
  unsigned char checksum;
}TDynStatus;
*/

unsigned char dyn2_convert_v1_status_packet(TDynInstruction inst,unsigned char *source, unsigned char *destination);
void dyn2_init_status_packet(unsigned char *packet,unsigned char id,TDynError error,unsigned short int length,unsigned char *data);
TDynError dyn2_get_status_error(unsigned char *packet);
/* read instruction status packet */
unsigned short int dyn2_get_read_status_data(unsigned char *packet,unsigned char *data);
unsigned char dyn2_get_read_status_id(unsigned char *packet);

#endif
