#ifndef _DYN_MODULE_H
#define _DYN_MODULE_H

#define     MODULE_MAX_NUM_MODELS     32

#include "dyn_manager.h"

typedef struct TDynModule{
  TDynManager *manager;
  unsigned short int models[MODULE_MAX_NUM_MODELS];
  unsigned char num_models;
  unsigned char assigned_ids[DYN_MANAGER_MAX_NUM_DEVICES];
  unsigned char num_assigned_ids;
  unsigned char period_count;
  void (*init)(void);
  void (*add_device)(unsigned char id,unsigned short int model);
  void (*setup)(void);
  void (*pre_process)(void);
  void (*post_process)(void);
}TDynModule;

//public functions
void dyn_module_init(TDynModule *module);
void dyn_module_add_model(TDynModule *module,unsigned short int model);
unsigned char dyn_module_get_num_models(TDynModule *module);
void dyn_module_add_device(TDynModule *module,unsigned char id, unsigned short int model);
unsigned char dyn_module_get_num_assigned_devices(TDynModule *module);
unsigned char dyn_moudle_device_is_assigned(TDynModule *module,unsigned char id);
void dyn_module_set_period(TDynModule *module,unsigned char period);
unsigned char dyn_module_get_period(TDynModule *module);
void dyn_module_set_init_fctn(TDynModule *module,void (*init)(void));
void dyn_module_set_add_device_fctn(TDynModule *module,void (*add_device)(unsigned char id,unsigned short int model));
void dyn_module_set_setup_fctn(TDynModule *module,void (*setup)(void));
void dyn_module_set_pre_process_fctn(TDynModule *module,void (*pre_process)(void));
void dyn_module_set_post_process_fctn(TDynModule *module,void (*post_process)(void));

#endif
