#include "dyn_module.h"

void dyn_module_init(TDynModule *module)
{
  unsigned char i;

  module->num_models=0x00;
  for(i=0;i<MODULE_MAX_NUM_MODELS;i++)
    module->models[i]=0x0000;
  for(i=0;i<DYN_MANAGER_MAX_NUM_DEVICES;i++)
    module->assigned_ids[i]=0x00;
  module->num_assigned_ids=0x00;
  module->period_count=0x00;
  module->init=0x00000000;
  module->add_device=0x00000000;
  module->setup=0x00000000;
  module->pre_process=0x00000000;
  module->post_process=0x00000000;
}

void dyn_module_add_model(TDynModule *module,unsigned short int model)
{
  unsigned char i;

  for(i=0;i<module->num_models;i++)
    if(module->models[i]==model)
      return;
  if(i<MODULE_MAX_NUM_MODELS)
  {
    module->models[i]=model;
    module->num_models++;
  }
}

unsigned char dyn_module_get_num_models(TDynModule *module)
{
  return module->num_models;
}

void dyn_module_add_device(TDynModule *module,unsigned char id, unsigned short int model)
{
  unsigned char i;
  
  for(i=0;i<module->num_models;i++)
  {
    if(model==module->models[i])
    {
      if(module->add_device!=0x00000000)
      {
        module->assigned_ids[id]=0x01;
        module->num_assigned_ids++;
        module->add_device(id,model);
      }
    }
  }
}

unsigned char dyn_module_get_num_assigned_devices(TDynModule *module)
{
  return module->num_assigned_ids;
}

unsigned char dyn_moudle_device_is_assigned(TDynModule *module,unsigned char id)
{
  if(id<DYN_MANAGER_MAX_NUM_DEVICES)
    return module->assigned_ids[id];
  else
    return 0x00;
}

void dyn_module_set_period(TDynModule *module,unsigned char period)
{
  if(period==0x00)
    module->period_count=0x01;
  else
    module->period_count=period;
}

unsigned char dyn_module_get_period(TDynModule *module)
{
  return module->period_count;
}

void dyn_module_set_init_fctn(TDynModule *module,void (*init)(void))
{
  module->init=init;
}

void dyn_module_set_add_device_fctn(TDynModule *module,void (*add_device)(unsigned char id,unsigned short int model))
{
  module->add_device=add_device;
}

void dyn_module_set_setup_fctn(TDynModule *module,void (*setup)(void))
{
  module->setup=setup;
}

void dyn_module_set_pre_process_fctn(TDynModule *module,void (*pre_process)(void))
{
  module->pre_process=pre_process;
}

void dyn_module_set_post_process_fctn(TDynModule *module,void (*post_process)(void))
{
  module->post_process=post_process;
}

