#ifndef USART1_L0_H
#define USART1_L0_H

#include "stm32l0xx_hal.h"
#include "usart_common.h"
#include "comm.h"

/* public functions */
void usart1_init(TComm *comm_dev,UART_InitTypeDef *conf,UART_AdvFeatureInitTypeDef *adv_conf,TUSART_IRQ_Priorities *priorities);
void usart1_config(TComm *comm_dev,UART_InitTypeDef *conf,UART_AdvFeatureInitTypeDef *adv_conf);
void usart1_set_priorities(TComm *comm_dev,TUSART_IRQ_Priorities *priorities);
/* IRQ functions */
unsigned char usart1_send_irq(unsigned char first_byte);
unsigned char usart1_enable_tx_irq(void);
unsigned char usart1_receive_irq(void);
unsigned char usart1_cancel_receive_irq(void);
/* DMA functions */
unsigned char usart1_send_dma(unsigned char *data,unsigned short int length);
unsigned char usart1_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usart1_cancel_receive_dma(void);

#endif
