#ifndef _MEM_MODULE_H
#define _MEM_MODULE_H

#define MAX_NUM_SEGMENTS         4

typedef struct
{
  unsigned short int start_address;
  unsigned short int length;
}TMemSegment;

typedef struct
{
  unsigned char num_ram_segments;
  TMemSegment ram_segments[MAX_NUM_SEGMENTS];
  unsigned char num_eeprom_segments;
  TMemSegment eeprom_segments[MAX_NUM_SEGMENTS];
  void (*write_cmd)(unsigned short int address,unsigned short int length,unsigned char *data);
  void (*read_cmd)(unsigned short int address,unsigned short int length,unsigned char *data);
}TMemModule;

void mem_module_init(TMemModule *module);
unsigned char mem_module_add_ram_segment(TMemModule *module,unsigned short int start_address, unsigned short int length);
unsigned char mem_module_add_eeprom_segment(TMemModule *module,unsigned short int start_address, unsigned short int length);

#endif
